import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Data Sources
*/
export interface DataAwsPartitionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/partition#id DataAwsPartition#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/partition aws_partition}
*/
export declare class DataAwsPartition extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "aws_partition";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/partition aws_partition} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsPartitionConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAwsPartitionConfig);
    get dnsSuffix(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get partition(): string;
    get reverseDnsPrefix(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
