import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Directory Service
*/
export interface DirectoryServiceSharedDirectoryAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter#id DirectoryServiceSharedDirectoryAccepter#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter#shared_directory_id DirectoryServiceSharedDirectoryAccepter#shared_directory_id}
    */
    readonly sharedDirectoryId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter#timeouts DirectoryServiceSharedDirectoryAccepter#timeouts}
    */
    readonly timeouts?: DirectoryServiceSharedDirectoryAccepterTimeouts;
}
export interface DirectoryServiceSharedDirectoryAccepterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter#create DirectoryServiceSharedDirectoryAccepter#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter#delete DirectoryServiceSharedDirectoryAccepter#delete}
    */
    readonly delete?: string;
}
export declare function directoryServiceSharedDirectoryAccepterTimeoutsToTerraform(struct?: DirectoryServiceSharedDirectoryAccepterTimeoutsOutputReference | DirectoryServiceSharedDirectoryAccepterTimeouts | cdktf.IResolvable): any;
export declare class DirectoryServiceSharedDirectoryAccepterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DirectoryServiceSharedDirectoryAccepterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DirectoryServiceSharedDirectoryAccepterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter aws_directory_service_shared_directory_accepter}
*/
export declare class DirectoryServiceSharedDirectoryAccepter extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_directory_service_shared_directory_accepter";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/r/directory_service_shared_directory_accepter aws_directory_service_shared_directory_accepter} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DirectoryServiceSharedDirectoryAccepterConfig
    */
    constructor(scope: Construct, id: string, config: DirectoryServiceSharedDirectoryAccepterConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get method(): string;
    get notes(): string;
    get ownerAccountId(): string;
    get ownerDirectoryId(): string;
    private _sharedDirectoryId?;
    get sharedDirectoryId(): string;
    set sharedDirectoryId(value: string);
    get sharedDirectoryIdInput(): string | undefined;
    private _timeouts;
    get timeouts(): DirectoryServiceSharedDirectoryAccepterTimeoutsOutputReference;
    putTimeouts(value: DirectoryServiceSharedDirectoryAccepterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DirectoryServiceSharedDirectoryAccepterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
